/**
* @file BubbleSort.java
*
* @brief This file contains the sorting.BubbleSort class.
*
* @author Philipp Bank, www.cypax.net\n
*
* @date June, 19th 2006 - first version
*
**/

package sorting;

import java.awt.*;

/**
* @class BubbleSort
* @brief The BubbleSort class extends the Sort class and sorts arrays with the bubblesort algorithm.
*
* The used bubblesort code is adapted from <a href="http://de.wikipedia.org/wiki/Bubblesort">http://de.wikipedia.org/wiki/Bubblesort</a>.
*/
public class BubbleSort extends Sort
{

/**
* @brief This is the sorting algorithm.
*
* The used bubblesort code is adapted from <a href="http://de.wikipedia.org/wiki/Bubblesort">http://de.wikipedia.org/wiki/Bubblesort</a>.
*/
  protected void doSort()
  {
    boolean sortiert;
    do
    {
      sortiert = true;
      for (int i = 1; i < theArray.length; i++)
      {
        if (theArray[i - 1] > theArray[i])
        {
          int tmp = theArray[i - 1];
          theArray[i - 1] = theArray[i];
          theArray[i] = tmp;
          sortiert = false;
        }
      }
      this.showArray();
      this.theLabel.setText(this.calcRuntime()+"ms");
      this.theLabel.validate();
    } while (!sortiert);
  }

}

