/**
* @file InsertionSort.java
*
* @brief This file contains the sorting.InsertionSort class.
*
* @author Philipp Bank, www.cypax.net\n
*
* @date June, 19th 2006 - first version
*
**/

package sorting;

import java.awt.*;

/**
* @class InsertionSort
* @brief The InsertionSort class extends the Sort class and sorts arrays with the insertionsort algorithm.
*
* The used insertionsort code is adapted from <a href="http://de.wikipedia.org/wiki/Insertionsort">http://de.wikipedia.org/wiki/Insertionsort</a>.
*/
public class InsertionSort extends Sort
{

/**
* @brief This is the sorting algorithm.
*
* The used insertionsort code is adapted from <a href="http://de.wikipedia.org/wiki/Insertionsort">http://de.wikipedia.org/wiki/Insertionsort</a>.
*/
  protected void doSort()
  {
    int pos;
    for (int i = 1; i <= theArray.length - 1; i++)
    {
      pos = binsearch(theArray, 0, i - 1, theArray[i]);
      move(i, pos, theArray);
      this.showArray();
      this.theLabel.setText(this.calcRuntime()+"ms");
      this.theLabel.validate();
    }
  }

  private void move(int i, int j, int[] a)
  {
    int tmp = a[i];
    for (int g = i; g >= j + 1; g--)
    {
      a[g] = a[g - 1];
    }
    a[j] = tmp;
  }

/**
* @brief A binary search algorithm.
*
* This is a binary search algorithm (<a href="http://en.wikipedia.org/wiki/Binary_search_algorithm">http://en.wikipedia.org/wiki/Binary_search_algorithm</a>)
* to locate the searched value in a array of integer.
*/
  private int binsearch(int[] a, int low, int high, int x)
  {
    int middle = 0;
    while (low <= high)
    {
      middle = (low + high) / 2;
      if (a[middle] == x) return middle;
      else if (a[middle] < x) low = middle + 1;
      else if (a[middle] > x) high = middle - 1;
    }
    return low;
  }

}
